using System;
using System.Reflection;
using System.Collections;
using System.Text;
using System.IO;
using System.CodeDom;
using System.CodeDom.Compiler;
using Microsoft.CSharp;



namespace NHFrog.Lib
{
	/// <summary>
	/// CodeManage ժҪ˵
	/// </summary>
	public class CodeManage
	{
		private const string commentString = @"-------------------------------------
 NHibernateFrog.
  
 kevin_Y
 2005.12  
 =====================================";
		private string _className;
		private string _namespaceName;
		private CodeCompileUnit _codeUnit;
		private CodeTypeDeclaration _class;
		private Hashtable _columns;
		public CodeManage(string pNamespaceName,string pClassName)
		{
			//
			// TODO: ڴ˴ӹ캯߼
			//
			this._className = pClassName;
			this._namespaceName = pNamespaceName;
			this._codeUnit = new CodeCompileUnit();
			this._class = new CodeTypeDeclaration(this._className);
			this._columns = new Hashtable();
			this.generateUnit();
		}

		/// <summary>
		/// ʼCodeCompileUnitԱ_codeUnit
		/// </summary>
		private void generateUnit()
		{			
			CodeNamespace cNamespace = new CodeNamespace(this._namespaceName);
			cNamespace.Comments.Clear();
			cNamespace.Comments.Add(new CodeCommentStatement(CodeManage.commentString));
			cNamespace.Imports.Add(new CodeNamespaceImport("System"));
		//	cNamespace.Imports.Add(new CodeNamespaceImport("System.Web"));
		//	cNamespace.Imports.Add(new CodeNamespaceImport("System.Web.UI"));
		//	cNamespace.Imports.Add(new CodeNamespaceImport("System.Web.UI.WebControls"));
			this._codeUnit.Namespaces.Add(cNamespace);			
		//	CodeTypeDeclaration cClass1 = new CodeTypeDeclaration(this._className);
		//	cClass1.BaseTypes.Add(comboBox1.Text);
			cNamespace.Types.Add(this._class);
		//	CodeMemberMethod[] cmm = GenerateOverrideMethods();
		//	CodeMemberProperty[] cmp = GenerateOverrideProperties();
		//	cClass1.Members.AddRange(cmp);
		//	cClass1.Members.AddRange(cmm);			
		}

		private void generateProperties()
		{
			CodeMemberProperty[] cms = new CodeMemberProperty[this._columns.Count];

			int i=0;
			IDictionaryEnumerator myEnumerator = this._columns.GetEnumerator();			
			while ( myEnumerator.MoveNext() )
			{						
				ColumnInfo col = (ColumnInfo)myEnumerator.Value;
				//˽б
				CodeMemberField field = new CodeMemberField(col.CSharpType,"m" + col.ColumnName);
				field.Comments.Add(new CodeCommentStatement(col.ColumnName+"˽б"));
				this._class.Members.Add(field);

				////ȡ÷
				cms[i] = new CodeMemberProperty();
				cms[i].Name = col.ColumnName;
				
				cms[i].Attributes = MemberAttributes.Public|MemberAttributes.Final;
				
				cms[i].HasGet = true;
				cms[i].GetStatements.Add(new CodeMethodReturnStatement(
					new CodeFieldReferenceExpression(new CodeThisReferenceExpression(),
					"m"+col.ColumnName)));
				
				cms[i].HasSet = true;
				cms[i].SetStatements.Add(new CodeAssignStatement(
					new CodeFieldReferenceExpression(
					new CodeThisReferenceExpression(),"m"+col.ColumnName),
					new CodePropertySetValueReferenceExpression()));   								                    
				
				cms[i].Type = new CodeTypeReference(col.CSharpType);
				//ע
				CodeCommentStatement[] comment = new CodeCommentStatement[3];
				comment[0] = new CodeCommentStatement(new CodeComment("<summary>",true));
				comment[1] = new CodeCommentStatement(new CodeComment("ȡ" + col.ColumnName,true));
				comment[2] = new CodeCommentStatement(new CodeComment("</summary>",true));
				cms[i].Comments.AddRange(comment);
			
				i++;
			}

			this._class.Members.AddRange(cms);			
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="pColumn"></param>
		public void AddProperty(ColumnInfo pColumn)
		{
			this._columns.Add(pColumn.ColumnName,pColumn);
		}

		/// <summary>
		/// ȡĴ
		/// </summary>
		/// <returns></returns>
		public string GenerateCode()
		{
			this.generateProperties();

			CodeDomProvider provider = new CSharpCodeProvider();
			ICodeGenerator gen = provider.CreateGenerator();
			// Create a TextWriter to a StreamWriter to an output file.
			StringWriter sv = new StringWriter();
			
			// Generate source code using the code generator.
			CodeGeneratorOptions options = new CodeGeneratorOptions();
			options.BracingStyle = "C";
			gen.GenerateCodeFromCompileUnit(this._codeUnit,sv,options);
						
			return sv.ToString();
		}
	}
}
