using System;
using System.IO;
using System.Resources;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;


namespace NHFrog.Lib
{
	//------------------------------------------------------------------------------
	/// <copyright from='1997' to='2001' company='Microsoft Corporation'>
	///    Ȩ (c) Microsoft CorporationȨ
	///
	///    ԴΪ Microsoft ߺ/ĵ
	///    Ĳ䡣й Microsoft ʾϸϢ
	///    Щϡ
	///
	/// </copyright>
	//------------------------------------------------------------------------------



	// <doc>
	// <desc>
	//     ʾʾʹ Treeview ؼ
	// </desc>
	// </doc>
	//
	public class TreeViewCtl : System.Windows.Forms.Form 
	{

		public TreeViewCtl() 
		{
			//
			// Windows ֧
			//
			InitializeComponent();

			FillDirectoryTree();
			imageListComboBox.SelectedIndex = 1;
			indentUpDown.Value = directoryTree.Indent;
		}

		/// <summary>
		///    ʹõԴ
		/// </summary>
		public new void Dispose() 
		{
			base.Dispose();
			components.Dispose();
		}

		// <doc>
		// <desc>
		//     ڸĸĿ¼ directoryTree 
		//     Ŀ¼
		// </desc>
		// </doc>
		//
		private void AddDirectories(TreeNode node) 
		{
			try 
			{
				DirectoryInfo dir = new DirectoryInfo(GetPathFromNode(node));
				DirectoryInfo[] e = dir.GetDirectories();

				for (int i = 0; i < e.Length; i++) 
				{
					string name = e[i].Name;
					if (!name.Equals(".") && !name.Equals("..")) 
					{
						node.Nodes.Add(new DirectoryNode(name));
					}
				}
			}
			catch (Exception e) 
			{
				MessageBox.Show(e.Message);
			}
		}

		// <doc>
		// <desc>
		//     ڸĽڵ㣬 directoryTree ΪڵӼ
		//     Ŀ¼
		// </desc>
		// </doc>
		//
		private void AddSubDirectories(DirectoryNode node) 
		{
			for (int i = 0; i < node.Nodes.Count; i++) 
			{
				AddDirectories(node.Nodes[i]);
			}
			node.SubDirectoriesAdded = true;
		}

		// <doc>
		// <desc>
		//     directoryTree  afterSelect ¼¼
		//     ıʾѡ directoryNode ·
		// </desc>
		// </doc>
		//
		private void directoryTree_AfterSelect(object source, TreeViewEventArgs e) 
		{
			Text = "Windows.Forms ļԴ - " + e.Node.Text;
		}

		// <doc>
		// <desc>
		//     directoryTree  beforeExpand ¼¼
		//     δչýڵ㣬չ
		// </desc>
		// </doc>
		//
		private void directoryTree_BeforeExpand(object source, TreeViewCancelEventArgs e) 
		{
			DirectoryNode nodeExpanding = (DirectoryNode)e.Node;
			if (!nodeExpanding.SubDirectoriesAdded)
				AddSubDirectories(nodeExpanding);
		}

		// <doc>
		// <desc>
		//      ڴ TreeViewCtl ʱʼ directoryTree
		// </desc>
		// </doc>
		//
		private void FillDirectoryTree() 
		{
			string[] drives = Environment.GetLogicalDrives();
			for (int i = 0; i < drives.Length; i++) 
			{
				if (PlatformInvokeKernel32.GetDriveType(drives[i]) == PlatformInvokeKernel32.DRIVE_FIXED) 
				{
					DirectoryNode cRoot = new DirectoryNode(drives[i]);
					directoryTree.Nodes.Add(cRoot);
					AddDirectories(cRoot);
				}
			}
		}

		// <doc>
		// <desc>
		//        ؽڵĿ¼·
		// </desc>
		// <retvalue>
		//        ڵĿ¼·
		// </retvalue>
		// </doc>
		//
		private string GetPathFromNode(TreeNode node) 
		{
			if (node.Parent == null) 
			{
				return node.Text;
			}
			return Path.Combine(GetPathFromNode(node.Parent), node.Text);
		}

		// <doc>
		// <desc>
		//        ˢ°Իȡڵµչ
		//        ڵ㡣
		// </desc>
		// <param term='expandedNodes'>
		//        ·ãЩ·ָˢʱ
		//        չ״̬нڵ㡣
		// </param>
		// <param term='startIndex'>
		//        ExpandedNodes Ӵ˴ʼӵ ExpandedNodes
		// </param>
		// <retvalue>
		//        µ StartIndex StartIndex ĸֵ + 
		//         ExpandedNodes 
		// </retvalue>
		// </doc>
		//
		private int Refresh_GetExpanded(TreeNode Node, string[] ExpandedNodes, int StartIndex) 
		{

			if (StartIndex < ExpandedNodes.Length) 
			{
				if (Node.IsExpanded) 
				{
					ExpandedNodes[StartIndex] = Node.Text;
					StartIndex++;
					for (int i = 0; i < Node.Nodes.Count; i++) 
					{
						StartIndex = Refresh_GetExpanded(Node.Nodes[i],
							ExpandedNodes,
							StartIndex);
					}
				}
				return StartIndex;
			}
			return -1;
		}

		// <doc>
		// <desc>
		//        ˢ°չ·ڲ ExpandedNodes е
		//        нڵ㡣
		// </desc>
		// <param term='node'>
		//        俪ʼչĽڵ㡣
		// </param>
		// <param term='expandedNodes'>
		//        ַ飬Ҫչнڵ·
		// </param>
		// </doc>
		//
		private void Refresh_Expand(TreeNode Node, string[] ExpandedNodes) 
		{

			for (int i = ExpandedNodes.Length - 1; i >= 0; i--) 
			{
				if (ExpandedNodes[i] == Node.Text) 
				{
					/*
					* Ϊȷʾչť뽫һ
					* ɼӼӵĿ¼
					*/
					AddSubDirectories((DirectoryNode) Node);
					Node.Expand();

					/* չڵ㣬չˢǰ
					* չӼ
					*/
					for (int j = 0; j < Node.Nodes.Count; j++) 
					{
						Refresh_Expand(Node.Nodes[j], ExpandedNodes);
					}

					return;
				}
			}
		}

		// <doc>
		// <desc>
		//     ˢͼɾнڵȻͨȡ
		//     ԭǡκ directoryView չ
		//     ڵˢº󶼽չ
		// </desc>
		// <param term='node'>
		//     - 俪ʼˢµĽڵ㡣ͨǸڵ㡣
		//     
		// </param>
		// </doc>
		//
		private void Refresh(TreeNode node) 
		{
			//  directoryTree
			if (node.Nodes.Count > 0) 
			{
				if (node.IsExpanded) 
				{
					//  node Ϊչڵ㣬
					// Щ node ΪĽڵ㡣
					string[] tooBigExpandedNodes = new string[node.GetNodeCount(true)];
					int iExpandedNodes = Refresh_GetExpanded(node,
						tooBigExpandedNodes,
						0);
					string[] expandedNodes = new string[iExpandedNodes];
					Array.Copy(tooBigExpandedNodes, 0, expandedNodes, 0,
						iExpandedNodes);

					node.Nodes.Clear();
					AddDirectories(node);

					// ˾Ŀ¼ӼʾΪչ/۵
					// ť
					AddSubDirectories((DirectoryNode)node);
					node.Expand();

					/*
					 * ӼһЩڵܴⲿӦ
					 * Ŀ¼ǰӼ
					 * ڿӼ
					 */
					for (int j = 0; j < node.Nodes.Count ; j++) 
					{
						if (node.Nodes[j].Nodes.Count > 0) 
						{
							// ӽھĿ¼Ӽ
							// ˢǰչģˢºչ
							Refresh_Expand(node.Nodes[j], expandedNodes);
						}
					}
				} 
				else 
				{
					/*
					 * ýڵ㲻չģҪǷ
					 * չκӼǣӦͨȡ
					 * Ŀ¼ԷⲿӦó/Ƴ
					 * κĿ¼
					 */
					node.Nodes.Clear();
					AddDirectories(node);
				}
			} 
			else 
			{
				/*
				 * УûκӼûбҪ
				 * չĽڵ㣬ⲿӦó/Ƴ
				 * κĿ¼Ӧ䷴ӳ
				 */
				node.Nodes.Clear();
				AddDirectories(node);
			}
		}

		private void checkBox1_Click(object source, EventArgs e) 
		{
			this.directoryTree.Sorted = checkBox1.Checked;
			for (int i = 0; i < directoryTree.Nodes.Count; i++) 
			{
				Refresh(directoryTree.Nodes[i]);
			}
		}

		private void imageListComboBox_SelectedIndexChanged(object source, EventArgs e) 
		{
			int index = imageListComboBox.SelectedIndex;
			if (index == 0) 
			{
				directoryTree.ImageList = null;
			} 
			else if (index == 1) 
			{
				directoryTree.ImageList = imageList1;
			} 
			else 
			{
				directoryTree.ImageList = imageList2;
			}
		}

		private void indentUpDown_ValueChanged(Object source, EventArgs e) 
		{
			directoryTree.Indent = (int)indentUpDown.Value;
		}

		private void CheckBox2_click(object source, EventArgs e) 
		{
			this.directoryTree.HotTracking = checkBox2.Checked;
		}

		private void CheckBox3_click(object source, EventArgs e) 
		{
			this.directoryTree.ShowLines = checkBox3.Checked;
		}

		private void CheckBox4_click(object source, EventArgs e) 
		{
			this.directoryTree.ShowRootLines = checkBox4.Checked;
		}

		private void CheckBox5_click(object source, EventArgs e) 
		{
			this.directoryTree.ShowPlusMinus = checkBox5.Checked;
		}

		private void CheckBox6_click(object source, EventArgs e) 
		{
			this.directoryTree.CheckBoxes = checkBox6.Checked;
		}

		private void CheckBox7_click(object source, EventArgs e) 
		{
			this.directoryTree.HideSelection = checkBox7.Checked;
		}

		/// <summary>
		///    Ҫ
		/// </summary>
		private System.ComponentModel.Container components;
		protected internal System.Windows.Forms.TreeView directoryTree;
		protected internal System.Windows.Forms.ImageList imageList1;
		protected internal System.Windows.Forms.ImageList imageList2;
		protected internal System.Windows.Forms.GroupBox grpTreeView;
		protected internal System.Windows.Forms.CheckBox checkBox1;
		protected internal System.Windows.Forms.ComboBox imageListComboBox;
		protected internal System.Windows.Forms.Label label1;
		protected internal System.Windows.Forms.NumericUpDown indentUpDown;
		protected internal System.Windows.Forms.Label label4;
		protected internal System.Windows.Forms.CheckBox checkBox2;
		protected internal System.Windows.Forms.CheckBox checkBox3;
		protected internal System.Windows.Forms.CheckBox checkBox4;
		protected internal System.Windows.Forms.CheckBox checkBox5;
		protected internal System.Windows.Forms.CheckBox checkBox6;
		protected internal System.Windows.Forms.CheckBox checkBox7;
		protected internal System.Windows.Forms.ToolTip toolTip1;

		/// <summary>
		///    ֧ķҪʹ
		///    ༭޸Ĵ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TreeViewCtl));

			this.components = new System.ComponentModel.Container();
			this.checkBox7 = new System.Windows.Forms.CheckBox();
			this.directoryTree = new System.Windows.Forms.TreeView();
			this.checkBox5 = new System.Windows.Forms.CheckBox();
			this.label4 = new System.Windows.Forms.Label();
			this.indentUpDown = new System.Windows.Forms.NumericUpDown();
			this.imageList2 = new System.Windows.Forms.ImageList();
			this.toolTip1 = new System.Windows.Forms.ToolTip(components);
			this.checkBox6 = new System.Windows.Forms.CheckBox();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.checkBox3 = new System.Windows.Forms.CheckBox();
			this.imageList1 = new System.Windows.Forms.ImageList();
			this.imageListComboBox = new System.Windows.Forms.ComboBox();
			this.checkBox4 = new System.Windows.Forms.CheckBox();
			this.grpTreeView = new System.Windows.Forms.GroupBox();
			this.checkBox2 = new System.Windows.Forms.CheckBox();
			this.label1 = new System.Windows.Forms.Label();

			checkBox7.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			checkBox7.Location = new System.Drawing.Point(16, 160);
			checkBox7.TabIndex = 6;
			checkBox7.CheckState = System.Windows.Forms.CheckState.Checked;
			checkBox7.Text = "hideSelected";
			checkBox7.Size = new System.Drawing.Size(100, 23);
			checkBox7.Checked = true;
			toolTip1.SetToolTip(checkBox7, "ؼнʱѡĽڵƳͻʾ");
			checkBox7.Click += new EventHandler(CheckBox7_click);

			directoryTree.ImageList = (ImageList)imageList1;
			directoryTree.ForeColor = (Color)System.Drawing.SystemColors.WindowText;
			directoryTree.Location = new System.Drawing.Point(24, 16);
			directoryTree.AllowDrop = true;
			directoryTree.TabIndex = 0;
			directoryTree.Indent = 19;
			directoryTree.Text = "treeView1";
			directoryTree.SelectedImageIndex = 1;
			directoryTree.Size = new System.Drawing.Size(200, 264);
			toolTip1.SetToolTip(directoryTree, "ָʾͬڵ֮Լڵӽڵ֮Ƿʾ");
			directoryTree.AfterSelect += new TreeViewEventHandler(directoryTree_AfterSelect);
			directoryTree.BeforeExpand += new TreeViewCancelEventHandler(directoryTree_BeforeExpand);

			checkBox5.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			checkBox5.Location = new System.Drawing.Point(16, 112);
			checkBox5.TabIndex = 4;
			checkBox5.CheckState = System.Windows.Forms.CheckState.Checked;
			checkBox5.Text = "showPlusMinus";
			checkBox5.Size = new System.Drawing.Size(120, 23);
			checkBox5.Checked = true;
			toolTip1.SetToolTip(checkBox5, "ָʾڸԱǷʾӺ/Űť");
			checkBox5.Click += new EventHandler(CheckBox5_click);

			label4.Location = new System.Drawing.Point(16, 224);
			label4.TabIndex = 9;
			label4.TabStop = false;
			label4.Text = ":";
			label4.Size = new System.Drawing.Size(48, 16);

			indentUpDown.Location = new System.Drawing.Point(88, 224);
			indentUpDown.Maximum = new System.Decimal(150d);
			indentUpDown.Minimum = new System.Decimal(18d);
			indentUpDown.TabIndex = 10;
			indentUpDown.Text = "18";
			indentUpDown.DecimalPlaces = 0;
			indentUpDown.Size = new System.Drawing.Size(120, 20);
			toolTip1.SetToolTip(indentUpDown, "ӽڵȣΪλ");
			indentUpDown.ValueChanged += new EventHandler(indentUpDown_ValueChanged);

			imageList2.ImageStream = (System.Windows.Forms.ImageListStreamer)resources.GetObject("imageList2.ImageStream");
			imageList2.TransparentColor = (Color)System.Drawing.Color.Transparent;

			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(502, 293);
			this.Text = "ͼ";

			toolTip1.Active = true;

			checkBox6.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			checkBox6.Location = new System.Drawing.Point(16, 136);
			checkBox6.TabIndex = 5;
			checkBox6.Text = "checkBoxes";
			checkBox6.Size = new System.Drawing.Size(100, 23);
			toolTip1.SetToolTip(checkBox6, "ָʾڽڵԱǷʾѡ");
			checkBox6.Click += new EventHandler(CheckBox6_click);

			checkBox1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			checkBox1.Location = new System.Drawing.Point(16, 16);
			checkBox1.TabIndex = 0;
			checkBox1.Text = "";
			checkBox1.Size = new System.Drawing.Size(100, 23);
			toolTip1.SetToolTip(checkBox1, "ָʾǷԽڵ");
			checkBox1.Click += new EventHandler(checkBox1_Click);

			checkBox3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			checkBox3.Location = new System.Drawing.Point(16, 64);
			checkBox3.TabIndex = 2;
			checkBox3.CheckState = System.Windows.Forms.CheckState.Checked;
			checkBox3.Text = "showLines";
			checkBox3.Size = new System.Drawing.Size(100, 23);
			checkBox3.Checked = true;
			toolTip1.SetToolTip(checkBox3, "ָʾͬڵ֮Լڵӽڵ֮Ƿʾߡ");
			checkBox3.Click += new EventHandler(CheckBox3_click);

			imageList1.ImageStream = (System.Windows.Forms.ImageListStreamer)resources.GetObject("imageList1.ImageStream");
			imageList1.TransparentColor = (Color)System.Drawing.Color.Transparent;

			imageListComboBox.ForeColor = (Color)System.Drawing.SystemColors.WindowText;
			imageListComboBox.Location = new System.Drawing.Point(88, 192);
			imageListComboBox.TabIndex = 8;
			imageListComboBox.Text = "";
			imageListComboBox.Size = new System.Drawing.Size(120, 21);
			imageListComboBox.SelectedIndexChanged += new EventHandler(imageListComboBox_SelectedIndexChanged);
			imageListComboBox.Items.AddRange((object[])new object[] {"ޣ", "ϵͳͼ", "λͼ"});

			checkBox4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			checkBox4.Location = new System.Drawing.Point(16, 88);
			checkBox4.TabIndex = 3;
			checkBox4.CheckState = System.Windows.Forms.CheckState.Checked;
			checkBox4.Text = "showRootLines";
			checkBox4.Size = new System.Drawing.Size(120, 23);
			checkBox4.Checked = true;
			toolTip1.SetToolTip(checkBox4, "ָʾǷڸڵ֮ʾߡ");
			checkBox4.Click += new EventHandler(CheckBox4_click);

			grpTreeView.Location = new System.Drawing.Point(248, 16);
			grpTreeView.TabIndex = 1;
			grpTreeView.TabStop = false;
			grpTreeView.Text = "ͼ";
			grpTreeView.Size = new System.Drawing.Size(248, 264);

			checkBox2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			checkBox2.Location = new System.Drawing.Point(16, 40);
			checkBox2.TabIndex = 1;
			checkBox2.Text = "hotTracking";
			checkBox2.Size = new System.Drawing.Size(100, 23);
			toolTip1.SetToolTip(checkBox2, "ָʾƵڵʱڵǷṩ");
			checkBox2.Click += new EventHandler(CheckBox2_click);

			label1.Location = new System.Drawing.Point(16, 194);
			label1.TabIndex = 7;
			label1.TabStop = false;
			label1.Text = "imageList:";
			label1.Size = new System.Drawing.Size(56, 16);

			grpTreeView.Controls.Add(checkBox7);
			grpTreeView.Controls.Add(checkBox6);
			grpTreeView.Controls.Add(checkBox5);
			grpTreeView.Controls.Add(checkBox4);
			grpTreeView.Controls.Add(checkBox3);
			grpTreeView.Controls.Add(checkBox2);
			grpTreeView.Controls.Add(label4);
			grpTreeView.Controls.Add(indentUpDown);
			grpTreeView.Controls.Add(label1);
			grpTreeView.Controls.Add(imageListComboBox);
			grpTreeView.Controls.Add(checkBox1);
			this.Controls.Add(grpTreeView);
			this.Controls.Add(directoryTree);

		}
		

	}
}


