using System;
using System.Data.OleDb;

namespace NHFrogGeneratorWizard
{
	/// <summary>
	/// ColumnInfo ժҪ˵
	/// </summary>
	public class ColumnInfo:DbObject
	{
		public ColumnInfo(string pName)
		{
			//
			// TODO: ڴ˴ӹ캯߼
			//
			this.ColumnName = pName;
			this.mCSharpType = typeof(object);
			this.MaxLength = -1;

		}

		public override string ToString()
		{
			string strPK = "";
			if(this.IsPrimaryKey)
				strPK="[PK]";
			return string.Format("{0} [{1}]{2}",
							this.ColumnName, 
							getTypeName(this.DataType,this.MaxLength),
							strPK);		
		}
		public override string Hello()
		{
			return "COLUMN";
		}

		private string getTypeName(object objType,int pLen)
		{
			string strReturn = "";
			System.Data.OleDb.OleDbType oleType = (System.Data.OleDb.OleDbType)objType;
			switch(oleType)
			{
				case OleDbType.WChar:
					strReturn = string.Format("WChar({0})",pLen);
					break;
				default:
					strReturn = oleType.ToString();
					break;
			}
			return strReturn;
		}


		private string mTableName;

		/// <summary>
		/// áȡTableName
		/// </summary>
		public string TableName
		{
			get
			{
				return (this.mTableName);
			}
			set
			{
				this.mTableName = value;
			}
		}

		private string mColumnName;

		/// <summary>
		/// áȡColumnName
		/// </summary>
		public string ColumnName
		{
			get
			{
				return (this.mColumnName);
			}
			set
			{
				this.mColumnName = value;
			}
		}
		private OleDbType mType;

		/// <summary>
		/// áȡType
		/// </summary>
		public OleDbType DataType
		{
			get
			{
				return (this.mType);
			}
			set
			{
				this.mType = value;

				switch(this.mType)
				{
					case OleDbType.VarChar:
					case OleDbType.WChar:
					case OleDbType.Char:
						this.mCSharpType = typeof(string);
						break;	
					case OleDbType.TinyInt:
						this.mCSharpType = typeof(System.SByte);
						break;
					case OleDbType.UnsignedTinyInt:
						this.mCSharpType = typeof(System.Byte);
						break;
					case OleDbType.SmallInt:
					case OleDbType.Integer:
						this.mCSharpType = typeof(int);
						break;
					case OleDbType.BigInt:
						this.mCSharpType = typeof(long);
						break;
					case OleDbType.Currency:
						this.mCSharpType = typeof(decimal);
						break;
					case OleDbType.DBTimeStamp:
					case OleDbType.Date:
						this.mCSharpType = typeof(DateTime);
						break;
					case OleDbType.Boolean:
						this.mCSharpType = typeof(bool);
						break;
					default:
						this.mCSharpType = typeof(object);
						break;
				}						
			}
		}

		private System.Type mCSharpType;

		/// <summary>
		/// ȡ е
		/// </summary>
		public System.Type CSharpType
		{
			get
			{
				return (this.mCSharpType);
			}			
		}

		private bool mIsPrimaryKey;

		/// <summary>
		/// áȡIsPrimaryKey
		/// </summary>
		public bool IsPrimaryKey
		{
			get
			{
				return (this.mIsPrimaryKey);
			}
			set
			{
				this.mIsPrimaryKey = value;
			}
		}
		
		private bool mAllowDBNull;

		/// <summary>
		/// áȡAllowDBNull
		/// </summary>
		public bool AllowDBNull
		{
			get
			{
				return (this.mAllowDBNull);
			}
			set
			{
				this.mAllowDBNull = value;
			}
		}
		private int mMaxLength;

		/// <summary>
		/// áȡMaxLength
		/// </summary>
		public int MaxLength
		{
			get
			{
				return (this.mMaxLength);
			}
			set
			{
				this.mMaxLength = value;
			}
		}

		/// <summary>
		/// ȡ
		/// </summary>
		/// <param name="pType"></param>
		/// <returns></returns>
		public static string GetIDGeneratorKindsDescript(OleDbType pType)
		{
			switch(pType)
			{
				case OleDbType.VarChar:
				case OleDbType.WChar:
				case OleDbType.Char:
					return "assigned";
				case OleDbType.SmallInt:
				case OleDbType.Integer:
				case OleDbType.BigInt:				
					return "native";//
				default:
					return "unknow";
			}				
		}

	}
}
