namespace NHFrogGeneratorWizard
{
	using System;
	using Microsoft.Office.Core;
	using Extensibility;
	using System.Runtime.InteropServices;
	using EnvDTE;
	using Microsoft.CSharp;
	using Microsoft.VisualBasic;
	using System.CodeDom;
	using System.CodeDom.Compiler;

	#region Read me for Add-in installation and setup information.
	// When run, the Add-in wizard prepared the registry for the Add-in.
	// At a later time, if the Add-in becomes unavailable for reasons such as:
	//   1) You moved this project to a computer other than which is was originally created on.
	//   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
	//   3) Registry corruption.
	// you will need to re-register the Add-in by building the MyAddin21Setup project 
	// by right clicking the project in the Solution Explorer, then choosing install.
	#endregion
	
	/// <summary>
	///   The object for implementing an Add-in.
	/// </summary>
	/// <seealso class='IDTExtensibility2' />
	[GuidAttribute("0CD85FFF-D606-42E6-BC35-9DE7F977BFA1"), ProgId("NHFrogGeneratorWizard.Connect")]
	public class Wizard : EnvDTE.IDTWizard
	{
		private EnvDTE.DTE _applicationObject;		

		public void Execute(object Application, int hwndOwner, 
			ref object[] ContextParams, 
			ref object[] CustomParams, 
			ref EnvDTE.wizardResult retval)
		{
			_applicationObject = (EnvDTE.DTE)Application;
			string wizardType = (string)ContextParams[0];
			string projectName = (string)ContextParams[1];
			EnvDTE.ProjectItems projectItems = (EnvDTE.ProjectItems)ContextParams[2];
			string newItemLocation = (string)ContextParams[3];
			string newItemName = (string)ContextParams[4];
			string productInstallDirectory = (string)ContextParams[5];
			bool runSilent = (bool)ContextParams[6];
			CodeDomProvider provider;
	
			if(newItemName.EndsWith(".cs"))
				provider = new CSharpCodeProvider();
			else if(newItemName.EndsWith(".vb"))
				provider = new VBCodeProvider();
			else
				throw new Exception("language not supported.");			

			GeneratorForm frm = new GeneratorForm();
			frm.CodeProvider = provider;
			frm.ApplicationObject = _applicationObject;
			frm.ItemLocation = newItemLocation;
			frm.InstallDirectory = newItemName;
			frm.ShowDialog();

		}
	}
}